<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<link rel="stylesheet" href="style.css" type="text/css"/>
<script src="code.js" type="text/javascript"></script>

<h1>Change Block Tracking</h1>

<p>
  Two common approaches to tracking changed blocks:
</p>
<table id="border">
  <tr>
    <th style="width: 20%">Approach</th>
    <th>Trade-offs</th>
  </tr>
  <tr>
    <td style="text-align:center; vertical-align:top;">Generation tag</td>
    <td>
      <ul>
	<li>Monotonically increasing tag tracked for each
	  cluster</li>
	<li>Set of changes since a point in time is all clusters with
	  generation id larger than the value at that point</li>
	<li>Multiple points in time tracked by same amount of metadata</li>
      </ul>
    </td>
  </tr>
  <tr>
    <td style="text-align:center; vertical-align:top;">Dirty bitmap</td>
    <td>
      <ul>
	<li>Bitmap that gets updated with each changed cluster</li>
	<li>Less metadata storage required for all changes since a
	  single point in time</li>
	<li>Multiple bitmaps required to track changes since multiple
	points in time</li>
      </ul>
    </td>
  </tr>
</table>
<p>Both approaches also have to balance granularity: more precision on
  what changed requires more metadata but can produce smaller
  incremental backups.</p>
